#-------------------------- 'summary' Module -------------------------
$SUMMARY = 1;
my ($Body3, $Body6);

sub summary_init{
    $Body3 = '^([\x21-\x7e\xa1-\xfe]{1,16}\s*(\.|,|\@|';
    $Body3 .= &str2euc('||');
    $Body3 .= ')\s*){0,2}[\x21-\x7e\xa1-\xfe]{1,16}\s*(';
    $Body3 .= &str2euc('Ǥ|ȿޤ|Ȥ⤦ޤ|Ȥޤ');
    $Body3 .= ')(.{0,2})?$'; #'

    $Body6 = '^(Date:|Subject:|Message-ID:|From:|';
    $Body6 .= &str2euc('̾|п|)|');
    $Body6 .= 'In .*(article|message)|\<\S+\@([\w-.]\.)+\w+\>|';
    $Body6 .= '(wrote|said|writes|says).{0,3}$|';
    $Body6 .= '(ֻǤ|reply\s*Ǥ|۩|勞|񤭤ޤ|ޤ|ä).{0,2}$'; #'
}
&summary_init;

sub summary_head{
    my $str = shift;
    my $lineno = shift;
    my $head = shift;
    my $filepath = shift;
    my $header = shift;
    my $st = shift;

    return 1 if $lineno == 1 && $str =~ /^From /;
    push(@$head, $str), return 1 if $str =~ /^\S+:/;
    if ($str =~ s/^\s//){
        return 0 unless @$head;
        $head->[$#$head] .= $str;
        return 1;
    }

    if ($str =~ /^$/){
        for $str (@$head){
            if ($str =~ /^(From|To|Cc|Newsgroup|Date)\:\s*(.*?)$/i){
                $$header .= "<strong>$1</strong>:<> "
                    . &metach(&str2euc($2, 'a2a')) . "</em><br$Xht>\n";
            }
            if ($str =~ s/^Subject:\s*//i){
                $$st = sprintf('<strong><a href="%s">%s</a></strong>',
                               $filepath, &metach(&str2euc($str, 'a2a')));
            }
        }
        return 0;
    }
    return -1;
}

sub summary_body{
    my $str = shift;
    my $body = shift;
    my $summary = shift;
    my $sizelimit = shift;

    if ($body > 0){
        ++$body;
        return $body if $str =~ /^[^\s\<]{1,10}\>|^\s*[\>\|\:]/;

        $str =~ s/^\s*\#?\s+//;
        $str =~ s/\s+$//;
        $str =~ s/\s\s+/ /g;
        if ($body <= 3){
            return $body if $str =~ /$Body3/io;
            return $body if $body <= 6 && $str =~ /$Body6/io;
        }
    }else{
        $str =~ s/\<[^\>]+\>/ /g;
    }
    $str =~ s/([\-\=\*\#])\1{2,}/$1$1/g;

    return 0 if $sizelimit <= length $$summary;
    if ($str !~ /^\s*$/){
        $$summary .= ' ' if defined($$summary) && length($summary);
        $$summary .= &metach(&euc_to_euc($str, {'summary' => 1}));
        return 0 if $sizelimit <= length $$summary;
    }
    return $body;
}

sub sn2sfn{
    my ($sn, $sfn) = @_;
    $sn =~ s/.$// while $sn =~ /(.)$/ && $sfn =~ s/$1$//;
    $sn = quotemeta($sn);
    &debug_log("sum: SRepSrc: $_[0] -> $sn");
    &debug_log("sum: SRepDst: $_[1] -> $sfn");
    push(@SRepSrc, $sn);
    push(@SRepDst, $sfn);
}

sub make_summary{
    my ($keydb, $keyno, $flag, $sizelimit) = @_;
    my ($dt, $st, $summary, $dd, $grep);
    local(*FSRC);

    my $offset = &indexpointer("RLISTINDEX$keydb", $keyno);
    my $filepath = &getsdb("RLIST_____$keydb", $offset);
    $filepath =~ s/\r*\n//;
    $filepath =~ s/\t.*$//;

    &debug_log("sum: $filepath");

    $sizelimit = 300 unless defined($sizelimit) && $sizelimit >= 0;

    my $size = (stat $filepath)[7];

    unless ($size && -r $filepath){
        if (-d $DiaryDir && $filepath =~ /\#(\d{4})(\d{4})\d*$/){
            my $diaryyear = $1;
            my $diarydate = $2;
            my $diarypath = "$DiaryDir/$diaryyear/d$diaryyear$diarydate.hnf";
            my $tmp = (stat $diarypath)[7];
            if (-r $diarypath && $tmp){
                $size = $tmp;
                $filepath = $diarypath;
                &debug_log("sum: hnf: $filepath");
            }
        }
    }

    unless ($size && -r $filepath){
        $filepath =~ s/\#.*$//;
        $size = (stat $filepath)[7];
        &debug_log("sum: $filepath");
    }

    unless ($size && &opentext(*FSRC, $filepath)){
        &replace($filepath);
        $filepath =~ s/^http\:\/\/[^\/]+//;
        unless (defined @SRepSrc){
            &sn2sfn($SCRIPT_NAME, $ScriptFileName);
            &sn2sfn($SCRIPT_NAME, $0);
            &sn2sfn($SCRIPT_NAME, $ENV{'SCRIPT_FILENAME'}) if $ENV{'SCRIPT_NAME'};
        }
        my $i;
        for ($i = 0; $i < @SRepSrc; $i++){
            my $sn = $SRepSrc[$i];
            my $sfn = $SRepDst[$i];
            my $fp = $filepath;
            $fp =~ s/^$sn/$sfn/o;
            &debug_log("sum: try: $fp");

            if (&opentext(*FSRC, $fp)){
                if (my $sz = (stat FSRC)[7]){
                    $filepath = $fp;
                    $size = $sz;
                    &debug_log("sum: replace: $filepath");
                    last;
                }
                close FSRC;
            }                    
        }
    }
    &debug_log("sum: $filepath");

    my $grpflag = ($HnsGrepGrp && $filepath =~ /\.hnf$/i);

    if ($size){
        my $head = 1;
        my $body = 0;
        my $lineno = 0;
        my $readsize = 0;
        my $grepline = 0;
        my $gflag = ($flag =~ /g/ && !$AlreadyGrep{$filepath} && length($Sword{$keydb}));
        my ($header, @head);
        my $buf;

        $dt = '<dt>';
        $dd = sprintf('<dd><a href="%s">%s</a> size (%d bytes)'
                      . "<br$Xht><br$Xht>\n",
                      $filepath, $filepath, $size);
        $grep = '';

        if ($gflag){
            unless (defined $GrepFunc{$keydb}){
                my $evalstr = '$GrepFunc{$keydb} = sub {';
                if ($PlainConv){
                    $evalstr .= '$_[0] =~ /' . $Sword{$keydb} . '/i;';
                }else{
                    $evalstr .= '$_[0] =~ s/(' . $Sword{$keydb} . ')/$EmTagS$1$EmTagE/gi;';
                }
                $evalstr .= '};';

                eval $evalstr;
            }
            
        }

        while (defined($str = <FSRC>)){
            last if $str =~ /\x00|^M[\x21-\x60]{60}$/;
            last if $str =~ /^Content-Type: /i && $str !~ /text|multipart/i;
            last if $grpflag && $str =~ /^GRP\s/;

            ++$lineno;
            $readsize += length $str;
            last if $Grep_MaxSize && $Grep_MaxSize < $readsize;
            last if $Grep_MaxLine && $Grep_MaxLine < $grepline;

            $str =~ s/\r*\n$//;
            if ($head){
                $head = &summary_head($str, $lineno, \@head,
                                      $filepath, \$header, \$st);
                $body = 1, next unless $head;
                if ($head < 0){
                    $body = -1;
                    $head = 0;
                    for $str (@head){
                        $body = &summary_body(&str2euc($str, 'a2a'), $body, \$summary, $sizelimit);
                        last unless $body;
                    }
                }
            }
            $str = &str2euc($str, 'a2a') if $gflag || $body;
            $body = &summary_body($str, $body, \$summary, $sizelimit) if $body;
            if ($gflag){
                $buf = &metach($str);
                $buf =~ s/([\xa1-\xfe].)/\xff$1/g;

                if (&{$GrepFunc{$keydb}}($buf)){
                    $buf =~ tr/\xff//d;
                    if ($PlainConv){
                        $grep .= "$lineno: $buf\n";
                    }else{
                        $grep .= "\n<strong>$lineno: </strong>$buf<br$Xht>";
                    }
                    ++$grepline;
                }
            }
        }
        if (!$PlainConv){
            $summary = metach($summary);
            $summary =~ s/([\xa1-\xfe].)/\xff$1/g;
            $summary =~ s/($Sword{$keydb})/$EmTagS$1$EmTagE/gi if length $Sword{$keydb};
            $summary =~ tr/\xff//d;
        }

        $AlreadyGrep{$filepath} = 1 if $gflag;
        return $grep if $flag !~ /[fs]/;
        $summary = "<dd>$header$summary" if $flag =~ /f/;
    }
    ($dt, $st, $summary, $dd, $grep);
}

1;
#---------------------- end of 'summary' Module ----------------------
