#----------------------- 'word search' Module ------------------------
sub ssub{
    local($totalhit, $x, *score, $key, $pat, $flag) = @_;
    my($buf);
    my($str) = $buf = &readindexindex($x);
    $buf =~ s/([\xa1-\xfe].)/\xff$1/g if $flag;
    if ($buf =~ /$pat/i){
        my($net, $hit) = &readindexscore($x, *score, $str);
        $$totalhit += $hit;
        $SubHit{$key}{$net}{$str} = 1;
        return 1;
    }
    return 0;
}

sub binsearch{
    # Keyword 򸡺롣
    local($origkey, *score) = @_;
    my($x, $l, $r, $p, $buf, $hit, $totalhit, $pat);
    my($key) = $origkey;
    my($regsearch, $forward, $backward, $nativecmp);

    if ($TSEARCH && ($key =~ /^\+\[.*\]$/)){
        return &tsearch($origkey, *score, $key);
    }

    if ($FIELD && ($fieldsearch = ($key =~ /^\+[^\:\s]+\:/))){
        return &field_search($origkey, *score, $key);
    }
    
    if (!($regsearch = ($key =~ s/^\/(.*)\/$/$1/))){
        $forward = ($key =~ s/(.)\*$/$1/);
        $backward = ($key =~ s/^\*(.)/$1/);
    }

    if ($regsearch){
        return &reg_search($origkey, *score, $key) if $REG;
        push(@DbErrors, "(Cannot use regular expressions)");
        return ($origkey, '', 0);
    }

    if ($backward){
        if ($BW){
            if ($key =~ /^([\xa1-\xfe][\xa1-\xfe])+$/){
                $Mb = &bwopen('MB', 'm') if $Mb < 0;
                return &bwsearch($origkey, *score, $key, $forward, 'MB') if $Mb;
            }
            if ($key =~ /^[\x21-\x7e]$/ && $REG){
                return &reg_search($origkey, *score, $forward? $key: "$key\$");
            }
            if ($key =~ /^[\x21-\x7e]{2,}$/){
                $Sb = &bwopen('SB', 's') if $Sb < 0;
                return &bwsearch($origkey, *score, $key, $forward, 'SB') if $Sb;
            }
            return &w_bw($origkey, *score, $key, $forward);
        }
        push(@DbErrors, "(Cannot use inside/suffix matching");
        return ($origkey, '', 0);
    }

    my $esc = ($key =~ s/^\\(.)/$1/)? "\\": '';
    if ($forward){
        $pat = "^" . &quote_meta($key);
    }

    $p = $l = 0;
    $r = $DbNdx{'INDEXINDEX'} - 1;
    $nativecmp = ('a' lt '');
    if ($IntType ne 'w' && $DbSize{'HASH'}){
        $x = ord($key) << 8;
        if ($key =~ /^.(.)/){
            $x |= ord($1);
            $r = &indexpointer(*HASH, 1 + $x) - 1;
        }elsif ($forward){
            $r = &indexpointer(*HASH, 0x100 + $x) - 1;
        }else{
            $r = &indexpointer(*HASH, 1 + $x) - 1;
        }
        $p = $l = &indexpointer(*HASH, $x);
        $nativecmp = 1;
    }

    if ($l <= $r){
        my $wordcnt = 0;
        while ($l <= $r){
            $x = int(($l + $r + 1) / 2);
            $buf = &readindexindex($x);
            if ($forward){
                if (index($buf, $key) == 0 &&
                    &ssub(\$totalhit, ($p = $x), *score, $origkey, $pat)){
                    while (&ssub(\$totalhit, --$x, *score, $origkey, $pat)){
                        %score = () if $MaxHit && $totalhit >= $MaxHit;
                        undef %{$SubHit{$origkey}} if $MaxMatch && ++$wordcnt >= $MaxMatch;
                    }
                    $x = $p;
                    while (&ssub(\$totalhit, ++$x, *score, $origkey, $pat)){
                        %score = () if $MaxHit && $totalhit >= $MaxHit;
                        undef %{$SubHit{$origkey}} if $MaxMatch && ++$wordcnt >= $MaxMatch;
                    }
                    if ($MaxHit && $totalhit >= $MaxHit){
                        $totalhit = 0;
                        %score = ('TooMany' => $Text{'hit'});
                    }elsif ($MaxMatch && $wordcnt >= $MaxMatch){
                        $totalhit = 0;
                        %score = ('TooMany' => $Text{'match'});
                    }
                    return ($origkey, '', $totalhit);
                }
            }elsif ($key eq $buf){
                $hit = &readindexscore($x, *score, $key);
                $hit = 0, %score = ('TooMany' => $Text{'hit'}) if $MaxHit && $hit >= $MaxHit;
                return ("$esc$key", '', $hit);
            }

            if (&unsignedcmp($key, $buf, $nativecmp) < 0){
                $r = $x - 1;
            }else{
                $l = $x + 1;
            }
        }

        if ($key =~ /^([\xa1-\xfe][\xa1-\xfe])[\xa1-\xfe]*$/){
            # kakasi ƤФʤΤǡʣθΤ
            # Ĺפ keyword  index Ӥ
            my $pre = $1;
            while ($x >= $p){
                $buf = &readindexindex($x);
                last if &unsignedcmp($buf, $pre, $nativecmp) < 0;
                if ($key =~ /^$buf/){
                    # keyword λĤϼθȤƿƥ롼֤
                    $origkey =~ s/^$buf//;
                    return ($buf, $origkey, &readindexscore($x, *score, $buf));
                }
                --$x;
            }
        }
    }
    return ($1, $origkey, 0) if $origkey =~ s/^(\xa5[\xa1-\xf3](\xa5[\a1-\xf3]|\xa1\xbc)*\*?)//;
    return ($1, $origkey, 0) if $origkey =~ s/^(\xa4[\xa1-\xf3](\xa4[\a1-\xf3]|\xa1\xbc)*\*?)//;
    return ($origkey, '', 0);
}

sub unsignedcmp {
    return ($_[0] cmp $_[1]) if $_[2];
    my ($str1, $str2) = @_;
    my ($ord1, $ord2);

    while (($ord1 = ord($str1)) == ($ord2 = ord($str2))) {
        last if ! $ord1;
        $str1 =~ s/^.//;
        $str2 =~ s/^.//;
    }
    $ord1 <=> $ord2;
}

sub wsearch{
    local($word) = @_;
    local(%score);
    my($hashp, $match, $name, $hit, @word, $sword, $wflag, $hflag);

    if ($word =~ /^[\xa1-\xfe]+$/
        and !($TinyMknmz && $word =~ /^[\xb0-\xfe]/)
        ){
        if ($OpMode eq 'inside'){
            $word = "*$word*";
            $RespTextOrig = 1;
        }elsif ($OpMode eq 'forward'){
            $word = "$word*";
            $RespTextOrig = 1;
        }
    }

    $wflag = ($HWMode ne 'on');
    $hflag = ($HWMode eq 'off'
              or $HWMode eq 'wakati'
              && $word =~ /^\*?\xa4[\xa1-\xf3](\xa4[\a1-\xf3]|\xa1\xbc)*\*?$/);

    while ($word ne ''){
        %score = ();
        ($match, $word, $hit) = &binsearch($word, *score);
        $wflag = 0 if length $word and $HWMode eq 'wakati';

        if (!$hit && ($hflag || $wflag)
            && $match =~ /^\*?\xa4[\xa1-\xf3](\xa4[\a1-\xf3]|\xa1\xbc)*\*?$/){
            $score{'Disable'} = 1;
        }

        $Hit{$match} = $score{'TooMany'}? $score{'TooMany'}: ($hit + 0);
        push(@Words, $match);

        if ($SubHit{$match}){
            my $key;
            for $key (keys %{$SubHit{$match}}){
                my $subword;
                for $subword (keys %{$SubHit{$match}->{$key}}){
                    push(@SWord, $sword . $subword);
                }
            }
            $sword = '';
        }elsif ($match !~ /^[\/\+]/){
            if ($word eq ''){
                push(@SWord, $sword . $match);
            }else{
                $sword .= $match;
            }
        }

        $hashp = &makehash;
        %$hashp = %score;
        push(@ScorePtr, $hashp);
        # äʬˤ @ScorePtr ȤꥹȤ
        # sub operate ǻȤƤ롣
        # ޤǽ֤ѤʤȤˤʤäƤΤǡ
        # ¤κݤդ뤳

        push(@word, $match);
    }
    if ($CACHE){
        &cache_write_list if $CacheChange;
        &cache_close;
    }
    return '{ ' . join(' ', @word) . ' }' if $#word > 0;
    join(' ', @word);
}

sub searchwords{
    my(@list) = @_;
    my($op) = '(and|or|not|\&\&|\&\&\&|[&|!.\-])';
    my($tmp, @tmp, @p, $p, $q);
    my $dq = "\"";
    my %pair = ("(" => ")", "{" => "}", $dq => $dq);

    foreach $tmp (@list){
        $SubQueryWords = scalar(@Words) if $tmp =~ /^\&\&\&$/;
        $tmp = &wsearch($tmp) unless $tmp =~ /^(and|or|not|\&\&|\&\&\&|[\-(){}&|!.\"])$/; #"
    }

    for $tmp (@list){
        if ($tmp =~ /^[\(\{]/ || ($tmp eq $dq && !$q)){
            unshift(@p, $tmp);
            $q = 1, $tmp = '{' if $tmp eq $dq;
            push(@tmp, $tmp);
        }elsif ($tmp =~ /^[\}\)]/ || ($tmp eq $dq && $q)){
            while (@p){
                $p = $pair{shift(@p)};
                if ($p eq $dq){
                    $q = 0;
                    push(@tmp, '}');
                }else{
                    push(@tmp, $p);
                }
                last if $tmp eq $p;
            }
        }else{
            push(@tmp, $tmp);
        }
    }
    while (@p){
        $p = $pair{shift(@p)};
        $p = '}' if $p eq $dq;
        push(@tmp, $p);
    }

    $tmp = ' ' . join(' ', &reducep(@tmp)) . ' ';
    while (
           # 黻ҤϢ³ϡͭ
           $tmp =~ s/ $op $op / $2 /
           # Ǹ夬黻Ҥʤк
           || $tmp =~ s/ $op $/ /
           # åľ黻Ҥʤк
           || $tmp =~ s/ $op ([\}\)]) / $1 /
           # Ƭα黻ҤϺ
           || $tmp =~ s/^ $op / /
           # åľ夬黻Ҥʤк
           || $tmp =~ s/ ([\(\{]) $op / $1 /
           ){;}
    $tmp =~ s/^\s+//;
    $tmp =~ s/\s+$//;
    $tmp =~ s/\s+/ /g;
    $tmp;
}

sub reducep{
    local(@tmp) = @_;
    if ($tmp[0] eq '(' and $tmp[$#tmp] eq ')'){
        my($ndx, $cnt) = (0, 0);
        for ($ndx = 1; $ndx < $#tmp; $ndx++){
            if ($tmp[$ndx] eq '('){
                ++$cnt;
            }elsif ($tmp[$ndx] eq ')'){
                last if --$cnt < 0;
            }
        }
        pop(@tmp), shift(@tmp) if !$cnt;
    }
    @tmp;
}

1;
#--------------------- End of 'word search' Module -------------------
